
from HTMLParser import HTMLParser
from HTMLParser import HTMLParseError
from urllib import FancyURLopener
from sgmllib import SGMLParser

import re

eventRE = re.compile( r"tip\(event,'([^']*)','([^']*)','([^']*)'\)" )

class CharrefParser( SGMLParser ):
    def __init__( self ):
        SGMLParser.__init__( self )

    def handle_data( self, data ):
        self.utf8 += data

    def handle_charref( self, ref ):
        try:
            c = unichr( int(ref) )
        except ValueError:
            c = '?'
        self.handle_data( c )
    
    def getUtf8( self, text ):
        self.utf8 = ''
        self.reset()
        self.feed( text )
        self.close()
        return self.utf8

class AdsotatePage( HTMLParser ):

    def __init__( self ):
        HTMLParser.__init__( self )
        self.charrefParser = CharrefParser()

    def process( self, url ):
        self.list = []
        file = FancyURLopener().open( url )
        for line in file:
            try:
                self.feed( line )
            except HTMLParseError, inst:
                self.reset()
        file.close()

        return self.list

    def handle_starttag( self, tag, attrs ):
        if tag == 'span':
            self.onSpan( attrs )

    def onSpan( self, attrs ):
        for name,value in attrs:
            if name == 'onmouseover':
                self.onMouseover( value )
                break

    def onMouseover( self, text ):
        match = eventRE.match( text )
        if match:
            chinese,pinyin,translation = match.group(3).decode( 'utf-8' ), self.charrefParser.getUtf8( match.group(2) ), match.group(1).decode( 'utf-8' )
            self.list.append( ( chinese, pinyin, translation ) )

