import os, re

TEMPLATE = """<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/DTD/loose.dtd">
<html lang="zh">
    <head>
        <meta http-equiv="content-type" content="text/html;charset=utf-8">
        <title>CRI Online</title>
        <link href="articles/style.css" rel="stylesheet" type="text/css" />
    </head>
<body>
  <a name="top"></a>
  <h1>CRI Online News Broadcasts</h1>

  <ul>
%s
  </ul>

</body>
</html>"""

if __name__ == "__main__":
    pages = ["articles/"+f for f in os.listdir("articles/") if f.endswith("htm")]
    pages = reversed(sorted(pages))
    content = []
    for page in pages:
        heading = re.findall("<h1>(.*?)</h1>", open(page).read())[0]
        content.append("""<li><a href="%s">%s</a></li>""" % (page, heading))
    content = "\n".join(content)

    out = open("index.html", "w")
    out.write(TEMPLATE % content)
    out.close()
